#include "AT91SAM9263-EK.h"
#include "AT91SAM9263.h"

#define MSDELAY 650000

void Delay()
{
	volatile unsigned delay;
	for(delay = 1; delay < MSDELAY;)
	{
		delay++;
	}
}

void dbgu_print_ascii(void)
{

}

void LED_Open (unsigned int LED_number)
{
	if( LED_number & AT91B_LED1 )
	{
	    AT91D_BASE_PIO_LED1->PIO_OER=(AT91D_BASE_PIO_LED1->PIO_OSR | AT91B_LED1);
	    AT91D_BASE_PIO_LED1->PIO_PER=(AT91D_BASE_PIO_LED1->PIO_PSR | AT91B_LED1);
	}
	
	if( LED_number & AT91B_LED2 )
	{
	    AT91D_BASE_PIO_LED2->PIO_OER=(AT91D_BASE_PIO_LED2->PIO_OSR | AT91B_LED2);
	    AT91D_BASE_PIO_LED2->PIO_PER=(AT91D_BASE_PIO_LED2->PIO_PSR | AT91B_LED2);
	}	
}

void LED_Set(unsigned int LED_number)
{
	if( LED_number & AT91B_LED1 )
	{
	    AT91D_BASE_PIO_LED1->PIO_CODR=AT91D_BASE_PIO_LED1->PIO_ODSR | AT91B_LED1;
	}	
	if( LED_number & AT91B_LED2 )
	{
	    AT91D_BASE_PIO_LED2->PIO_CODR=AT91D_BASE_PIO_LED2->PIO_ODSR | AT91B_LED2;
	}
}

void LED_Clear(unsigned int LED_number)
{
	if( LED_number & AT91B_LED1 )
	{
		AT91D_BASE_PIO_LED1->PIO_SODR=(AT91D_BASE_PIO_LED1->PIO_ODSR | AT91B_LED1 );
	} 
	else if( LED_number & AT91B_LED2 ) {
		AT91D_BASE_PIO_LED2->PIO_SODR=(AT91D_BASE_PIO_LED2->PIO_ODSR | AT91B_LED2 );
	}
}

unsigned int LED_GetStatus(unsigned int LED_number)
{
	if( LED_number == 1 )
	{
		return ( !((AT91D_BASE_PIO_LED1->PIO_ODSR & AT91B_LED2) >> 8) );
	} 
	else if( LED_number == 2 ) {
		return ( !((AT91D_BASE_PIO_LED2->PIO_ODSR & AT91B_LED2) >> 29) );
	} 
	else {
		return 0;
	}
}

void LED_Toggle(unsigned int LED_number)
{
	unsigned int status;
	status = LED_GetStatus(LED_number);
	LED_Set( LED_number & status );
	LED_Clear( LED_number & (!status) );	
}

void Button_Open(unsigned int Button_number)
{
	AT91C_BASE_PMC->PMC_PCER = AT91B_BP1;
	if( Button_number == 1 )
	{
		AT91D_BASE_PIO_BP->PIO_ODR = AT91D_BASE_PIO_BP->PIO_OSR | AT91C_PIO_PC5;
		AT91D_BASE_PIO_BP->PIO_PER = AT91D_BASE_PIO_BP->PIO_PSR | AT91C_PIO_PC5;
	} 
	else if( Button_number == 2 ) {
		AT91D_BASE_PIO_BP->PIO_ODR = AT91D_BASE_PIO_BP->PIO_OSR | AT91C_PIO_PC4;
		AT91D_BASE_PIO_BP->PIO_PER = AT91D_BASE_PIO_BP->PIO_PSR | AT91C_PIO_PC4;
	}
}

unsigned int Button_IsPressed(unsigned int Button_number)
{
	if( Button_number == 1 )
	{
		return ( !((AT91D_BASE_PIO_BP->PIO_PDSR & AT91C_PIO_PC5)>>5) );
	} 
	else if( Button_number == 2 ) {
		return ( !((AT91D_BASE_PIO_BP->PIO_PDSR & AT91C_PIO_PC4)>>4) );
	} 
	else {
		return 0;
	}
}

unsigned int Button_Read( void )
{
	while(1)
	{
		if( Button_IsPressed(1) )
			return 1;
		if( Button_IsPressed(2) )
			return 2;	
	}
}

int main(void)
{
	LED_Open ((AT91B_LED1 | AT91B_LED2));
	LED_Clear((AT91B_LED1 | AT91B_LED2));
	Button_Open(1);
	
	while(1)
	{
		if( Button_Read() == 2)
		{
		LED_Set((AT91B_LED1 | AT91B_LED2));
		Delay();
		}
	}
	return 0;
}
